<?php
require_once dirname(__FILE__) . '/../header.php';

if (isset($_JSON['email'])) {
    if (strpos($_JSON['email'], '@') !== false)  {
        $email = explode('@', $_JSON['email'], 2);
        if (isset($email[1])) {
            if (strpos($email[1], '.') !== false) {
                $provider = strtolower(explode(".", $email[1])[0]);
                $supported = $main->ETVGetSupport();
                if (isset($supported[$provider])) {
                    $configuration = $supported[$provider];
                    if (isset($configuration['path'])) {
                        $parameter = [
                            'email' => base64_encode($_JSON['email']),
                        ];

                        // Parameter
                        $configurationSetting = $main->configurationGetProps();
                        $parameterData = $configurationSetting['parameter'];
                        if (!empty($parameterData)) {
                            $parameter[$parameterData] = '';

                        }

                        if (isset($_JSON['return'])) {
                            if (!empty($_JSON['return'])) {
                                $parameter['return'] = base64_encode($_JSON['return']);

                            }
                        }
                        
                        die(json_encode(['status' => true, 'message' => '', 'data' => [
                            'path' => $configuration['path'] . '?' . http_build_query($parameter),
                        ]]));
                        
                    }
                }
            }
        }
    }
}
die(json_encode(['status' => false, 'message' => '', 'data' => []]));