<?php
trait EPAPI {
    public function apiGet($url, $data = [], $cache = 0, $useBuildQuery = true, $backgroundAPI = false, $laterAPI = false) {
        $id = md5($url . json_encode($data));
        $dir = dirname(__FILE__) . '/../../.wexler/cache';
        if (!file_exists($dir)) mkdir($dir, 0755, true);
        $path = $dir . '/' . $id . '.data';
        if ($cache > 0) {
            if (file_exists($path)) {
                if (filemtime($path) > (time() - $cache)) {
                    return json_decode(file_get_contents($path), true);

                }
            }
        }

        if ($this->APIBackgroundable && $backgroundAPI) {
            $this->APIPending[] = [
                'url' => $url,
                'data' => $data,
                'cache' => $cache,
                'useBuildQuery' => $useBuildQuery,
            ];
            return [];

        } else {
            foreach ($this->server as $key => $value) {
                $data = $this->curl($value . $url, $data, $useBuildQuery);
                if ($data) {
                    if ($cache > 0) {
                        @file_put_contents($path, $data);
        
                    }
                    $aa = json_decode($data, true);
                    $aa['_raw'] = $data;
                    return $aa;
                    
                } else {
                    if ($laterAPI) {
                        $id = $this->RandUnik(25);
                        $path = $dir . '/' . $id . '.data';
                        file_put_contents($path, json_encode([
                            'url' => $url,
                            'data' => $data,
                            'unixtime' => time(),
                        ]));

                    } else {
                        continue;

                    }
                }
            }
            return [];
        }
    }
}